//
//  GVCommonArithmetics.h
//  GVFramework
//
//  Created by Vlad Gorloff on 22.08.12.
//  Copyright (c) 2012 Vlad Gorloff. All rights reserved.
//

#ifndef __GVFramework__GVCommonArithmetics_H__
#define __GVFramework__GVCommonArithmetics_H__

typedef enum
{
	kGVMouseTrackingStatus_Inactive = 0,
	kGVMouseTrackingStatus_DragActive,
	kGVMouseTrackingStatus_ResetToDefault

} KGVMouseTrackingStatus;

#if defined(__cplusplus)
extern "C"
{
#endif

    float  GVPlaceFloatValueInRange(float value, float min, float max);
    double GVPlaceDoubleValueInRange(double value, double min, double max);
    long   GVPlaceLongValueInRange(long value, long min, long max);

#if defined(__cplusplus)
}
#endif


#ifdef __cplusplus
#include <string>

#pragma mark Template functions
template <typename Type> inline void deleteAndZero (Type& pointer) {
    delete pointer;
    pointer = nullptr;
}

template <typename T> inline T GVPlaceNumberValueInRange (T value, T min, T max)
{
    T result = value;

    if ( value < min )
        result = min;

    if ( value > max )
        result = max;

    return result;
}

#pragma mark Helper functions
std::string std_sprintf(const char* fmt, ...);
void print_array(const float * array, long size, int columns = 3);

#endif

#endif // __GVFramework__GVCommonArithmetics_H__